//------------------------------------
//     BD Bot 2.1a (Alpha)
//         09/18/2005
// bots.sscentral.com/bdwinsalt
//-----------------------------------
package twcore.bots.bdbot2;
import twcore.core.*;
import java.util.*;
import java.io.*;
import java.lang.*;
import java.math.*;
public class bdbot2 extends SubspaceBot
{    
    private EventRequester events;
    private CommandInterpreter cmds;
    private OperatorList oplist;
ArrayList log;
ArrayList logg;
ArrayList ppl;
ArrayList cmdlog;
BotSettings         m_botSettings;
private int idleTime;


    public bdbot2(BotAction botAction)
    {
        super(botAction);
        log = new ArrayList();
        logg = new ArrayList();
        ppl = new ArrayList();
        cmdlog = new ArrayList();
        m_botAction = botAction;
        m_botSettings = m_botAction.getBotSettings();
        events = m_botAction.getEventRequester();
        events.request(EventRequester.PLAYER_ENTERED);
        events.request(EventRequester.MESSAGE); 
        cmds = new CommandInterpreter(m_botAction); 
        oplist = m_botAction.getOperatorList(); 
        addCommands();
        idleTime = m_botSettings.getInt("IdleReturnTime");
    }
    public void handleEvent(LoggedOn event)
    {
        BotSettings config = m_botAction.getBotSettings();
        String initial = config.getString("InitialArena");
        m_botAction.joinArena(initial);
String msg;
String bpass = config.getString( "Billerpassword" );
String login = config.getString( "LoginMethod" );
        m_botAction.sendUnfilteredPublicMessage( login + " " + bpass );
String chat = config.getString( "Chat" );
m_botAction.sendUnfilteredPublicMessage( "?chat=" + chat );
m_botAction.sendChatMessage( "I have logged in using chat(s): " + chat );
try{
Calendar c = Calendar.getInstance();
        String timestamp = "Bot up since: " + c.get( c.HOUR_OF_DAY ) + ":" + c.get( c.MINUTE ) + ":" + c.get( c.SECOND ) + " [" + c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + "]";
        PrintWriter out = new PrintWriter( new FileWriter( "twcore/bots/time.log" ));
            out.println( timestamp );
            for( Iterator i = ppl.iterator(); i.hasNext(); ){
                out.println( (String)i.next() );
            }
            out.close();
        }catch(Exception e){
            Tools.printStackTrace( e );
        }
    }
 public void handleEvent(PlayerEntered event){
String name = event.getPlayerName();
try{
BufferedReader in = new BufferedReader( new FileReader("greet.txt") );
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( name, line );
} while ( line != null );
in.close();
 } catch( Exception e ){
m_botAction.sendPrivateMessage( name, "Welcome!" );
}
try{
            PrintWriter out = new PrintWriter( new FileWriter( "players.txt" ));
            ppl.add( name );
            for( Iterator i = ppl.iterator(); i.hasNext(); ){
                out.println( (String)i.next() );
            }
            out.close();
        }catch(Exception e){
            Tools.printStackTrace( e );
        }
}
    public void handleEvent(Message event)

    {
        cmds.handleEvent(event);
    } 
    public void addCommands()  
{
        int ok = Message.PRIVATE_MESSAGE | Message.PUBLIC_MESSAGE | Message.TEAM_MESSAGE | Message.OPPOSING_TEAM_MESSAGE | Message.REMOTE_PRIVATE_MESSAGE;
        cmds.registerCommand("!help",ok,this,"help");
        cmds.registerCommand("!shutdown",ok,this,"shutdown");
        cmds.registerCommand("!go",ok,this,"go");
        cmds.registerCommand("!version",ok,this,"version");
        cmds.registerCommand("!sex",ok,this,"sex");
        cmds.registerCommand("!staff",ok,this,"staff");
        cmds.registerCommand("!ban",ok,this,"ban");
        cmds.registerCommand("!say",ok,this,"say");
        cmds.registerCommand("!error",ok,this,"error");
        cmds.registerCommand("!errorlist",ok,this,"errorlist");
        cmds.registerCommand("!errorclear",ok,this,"errorclear");
        cmds.registerCommand("!addgreet",ok,this,"addgreet");
        cmds.registerCommand("!greet",ok,this,"greet");
        cmds.registerCommand("!givenews",ok,this,"givenews");
        cmds.registerCommand("!owner",ok,this,"owner");
        cmds.registerCommand("!setnews",ok,this,"setnews");
        cmds.registerCommand("!kill",ok,this,"kill");
        cmds.registerCommand("!spec",ok,this,"spec");
        cmds.registerCommand("!stfu",ok,this,"stfu");
        cmds.registerCommand("!changelog",ok,this,"changelog");
        cmds.registerCommand("!buy-bdwinsalt",ok,this,"buy");
        cmds.registerCommand("!info",ok,this,"info");
        cmds.registerCommand("!chat",ok,this,"chat");
        cmds.registerCommand("!zone",ok,this,"zone");
        cmds.registerCommand("!arena",ok,this,"arena");
        cmds.registerCommand("!links",ok,this,"links");
        cmds.registerCommand("!apply",ok,this,"apply");
        cmds.registerCommand("!applyhelp",ok,this,"applyhelp");
        cmds.registerCommand("!applicants",ok,this,"applicants");
        cmds.registerCommand("!delapps",ok,this,"delapps");
        cmds.registerCommand("!happybirthday",ok,this,"happybirthday");
        cmds.registerCommand("!coin",ok,this,"Coin");
        cmds.registerCommand("!8ball",ok,this,"rand");
        cmds.registerCommand("!viewnews",ok,this,"viewnews");
        cmds.registerCommand("!hooker",ok,this,"hooker");
        cmds.registerCommand("!ezpz",ok,this,"ezpz");
        cmds.registerCommand("!log",ok,this,"log");
        cmds.registerCommand("!logdel",ok,this,"logdel");
        cmds.registerCommand("!rules",ok,this,"rules");
        cmds.registerCommand("!giverules",ok,this,"giverules");
        cmds.registerCommand("!buptime",ok,this,"buptime");
        cmds.registerCommand(".help",ok,this,"help");
        cmds.registerCommand(".shutdown",ok,this,"shutdown");
        cmds.registerCommand(".go",ok,this,"go");
        cmds.registerCommand(".version",ok,this,"version");
        cmds.registerCommand(".sex",ok,this,"sex");
        cmds.registerCommand(".staff",ok,this,"staff");
        cmds.registerCommand(".ban",ok,this,"ban");
        cmds.registerCommand(".say",ok,this,"say");
        cmds.registerCommand(".error",ok,this,"error");
        cmds.registerCommand(".errorlist",ok,this,"errorlist");
        cmds.registerCommand(".errorclear",ok,this,"errorclear");
        cmds.registerCommand(".addgreet",ok,this,"addgreet");
        cmds.registerCommand(".greet",ok,this,"greet");
        cmds.registerCommand(".givenews",ok,this,"givenews");
        cmds.registerCommand(".owner",ok,this,"owner");
        cmds.registerCommand(".setnews",ok,this,"setnews");
        cmds.registerCommand(".kill",ok,this,"kill");
        cmds.registerCommand(".spec",ok,this,"spec");
        cmds.registerCommand(".stfu",ok,this,"stfu");
        cmds.registerCommand(".changelog",ok,this,"changelog");
        cmds.registerCommand(".buy-bdwinsalt",ok,this,"buy");
        cmds.registerCommand(".info",ok,this,"info");
        cmds.registerCommand(".chat",ok,this,"chat");
        cmds.registerCommand(".zone",ok,this,"zone");
        cmds.registerCommand(".arena",ok,this,"arena");
        cmds.registerCommand(".links",ok,this,"links");
        cmds.registerCommand(".apply",ok,this,"apply");
        cmds.registerCommand(".applyhelp",ok,this,"applyhelp");
        cmds.registerCommand(".applicants",ok,this,"applicants");
        cmds.registerCommand(".delapps",ok,this,"delapps");
        cmds.registerCommand(".happybirthday",ok,this,"happybirthday");
        cmds.registerCommand(".coin",ok,this,"Coin");
        cmds.registerCommand(".8ball",ok,this,"rand");
        cmds.registerCommand(".viewnews",ok,this,"viewnews");
        cmds.registerCommand(".hooker",ok,this,"hooker");
        cmds.registerCommand(".ezpz",ok,this,"ezpz");
        cmds.registerCommand(".log",ok,this,"log");
        cmds.registerCommand(".logdel",ok,this,"logdel");
        cmds.registerCommand(".rules",ok,this,"rules");
        cmds.registerCommand(".giverules",ok,this,"giverules");
        cmds.registerCommand(".buptime",ok,this,"buptime");
    }
      public void help(String name, String msg) 
    {
        final String[] help ={
            "-------------------------------------------------",
            "------------Player Command List------------------",
            "-------------------------------------------------",
            "!sex            - Sends a sex message.",
            "!coin           - Simple coin toss.",
            "!8ball (msg)    - Ask it a question.",
            "!owner          - Tells you who owns the bot.",
            "!rules          - Displays zone rules.",
            "!staff          - Sends a list of zone staff.",
            "!links          - Sends important links.",
            "!error (msg)    - Sends an error report.",
            "!version        - Sends bot version information.",
            "!apply          - Sends a staff application.",
            "!applyhelp      - Sends !apply format.",
            "-------------------------------------------------" };        
        
        final String[] sysopHelp = {
            "",
            "--------------------------------------------------------------------",
            "------------------------- Sysop Commands ---------------------------",
            "--------------------------------------------------------------------",
            "!errorlist      - Sends a list of error reports.",
            "!errorclear     - Clears all errors on the errorlist.",
            "!changelog      - Displays the changes made to the bot.",
            "!applicants     - Displays the applications for staff.",
            "!ezpz           - Sends an arena-wide ez pz message.",
            "!hooker         - Sends a hooker message.",
            "!info           - Displays the bots info.",
            "!chat           - Sets the bot's chat channel.",
            "!log            - Displays the staff command log."};
            
        final String[] smodHelp = {
            "",
            "--------------------------------------------------------------------",
            "------------------------- Smod Commands ----------------------------",
            "--------------------------------------------------------------------",
            "!go (arena)     - Sends the bot to another arena.",
            "!addgreet       - Changes the greeting message.",
            "!greet          - Displays the current greeting message.",
            "!viewnews       - Displays the current news.",
            "!givenews       - Sends the news to the arena.",
            "!setnews        - Changes the news.",
            "!zone           - Sends a zone wide message."};
            
        final String[] modHelp = {
            "",
            "--------------------------------------------------------------------",
            "Moderator: !ban , !kill , !spec , !stfu , !arena , !say , !giverules",
            "--------------------------------------------------------------------"};
                    
            
        m_botAction.privateMessageSpam(name, help);
        
        if (oplist.isOwner(name))
        {
            m_botAction.sendPrivateMessage(name, "");
            m_botAction.sendPrivateMessage(name, "|Owner: !shutdown, !logdel|");
        }
            
        if (oplist.isSysop(name))
            m_botAction.privateMessageSpam(name, sysopHelp);
            
        if (oplist.isSmod(name))
                m_botAction.privateMessageSpam(name, smodHelp);
                    
        if (oplist.isER(name))
            m_botAction.privateMessageSpam(name, modHelp);        
    }

    public void shutdown(String name, String msg)
    {
if(oplist.isSysop(name)){
m_botAction.sendPrivateMessage( name, "Good bye." );
m_botAction.sendChatMessage( name + " has commanded me to shut down. Shutting down in 3 seconds..." );
try{
Thread.sleep( 3000 );
            m_botAction.die();
            } catch ( InterruptedException e ){
            System.out.println( "Bot shutdown delay ignored." );
            }
      } else {
m_botAction.sendPrivateMessage( name, "Sorry, you have to be a System Operator to use this." );
    }
}
    public void go(String name, String msg)
    {
        if(oplist.isSmod(name))
            m_botAction.changeArena(msg);
m_botAction.sendRemotePrivateMessage( name, "Going to " + msg + " arena." );
m_botAction.sendPrivateMessage( name, "Going to " + msg + " arena." );
    } 
public void version(String name, String msg)
{
//--------------------------------------------------------------------
//Don't you dare change my version tag. Leave this alone!
//Bad things happen to people who take credit for other people's work.
//--------------------------------------------------------------------
m_botAction.sendPrivateMessage( name, "Name: BD Bot 2.1a   Maker: BDwinsAlt [BDwinsAlt@GMail.com]" );
 }
public void sex(String name, String msg)
{
m_botAction.sendUnfilteredPrivateMessage( name, "xXx, Unf Unf Unf!" );
}
public void staff(String name, String msg)
{
try{
BufferedReader in = new BufferedReader( new FileReader( "twcore/bots/bdbot2/staff.txt" ));
            String line = "";
            do{
                line = in.readLine();
                if( line == null ) break;
                m_botAction.sendPrivateMessage( name, line );
            } while( line != null );
            in.close();
        } catch( Exception e ){
            m_botAction.sendPrivateMessage( name, "Error reading staff.txt file, try again later." );
log.add( "ERROR:Staff.txt was not found when !staff was typed." );
Tools.printStackTrace( "Error reading staff.txt file", e );
        }
}
public void ban(String name, String msg)
{
String bandays = m_botSettings.getString("BanDays");
if(oplist.isER(name))
m_botAction.sendUnfilteredPublicMessage( "?ban " + "-d=" + bandays + " " + msg );
m_botAction.sendPrivateMessage( name, "I have banned " + msg + " for " + bandays + " day(s). Contact a level 3 operator or high to get it removed." );
m_botAction.sendChatMessage( name + " has banned " + msg + " for " + bandays + " days." );
Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : " + "!ban " + msg );
System.out.println( "BD Bot 2.1: " + name + " has banned " + msg + " for " + bandays + " day(s)." );
}
public void say(String name, String msg)
{
if(oplist.isER(name))
m_botAction.sendPublicMessage( msg );
Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !say " + msg );
}
public void error(String name, String msg){
Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";        
try{
            PrintWriter out = new PrintWriter( new FileWriter( "twcore/bots/bdbot2/errors.txt" ));          
log.add( name + " : " + msg );
            for( Iterator j = log.iterator(); j.hasNext(); ){
                out.println( (String)j.next() );
            }
            out.close();
m_botAction.sendPrivateMessage( name, "Error report sent. Thank you for your help." );
        }catch(Exception e){
            Tools.printStackTrace( e );
m_botAction.sendPrivateMessage( name, "Could not send error report." );
        }
    }
public void errorlist(String name, String msg){
if(oplist.isSysop(name)){
int z = 0;
for (int i = 0; i < log.size(); i++) 
{
   m_botAction.sendPrivateMessage( name, "Error " + (i + 1) + ": " + log.get(i) );
}
if( log.size() == 0 ){
m_botAction.sendPrivateMessage( name, "No Errors Reported." );
} else {
m_botAction.sendPrivateMessage( name, "Total Errors: " + log.size() );
  }
}
}
public void errorclear(String name, String msg){
if(oplist.isSysop(name))
log.clear();
m_botAction.sendPrivateMessage( name, "Error Messages Cleared." );
}
public void addgreet(String name, String msg){
if(oplist.isSmod(name))
try{
            PrintWriter out = new PrintWriter( new FileWriter( "twcore/bots/bdbot2/greet.txt" ));
            out.println( msg );
            out.close();
m_botAction.sendPrivateMessage( name, "New Greet Msg: " + msg );
        }catch(Exception e){
            Tools.printStackTrace( e );
m_botAction.sendPrivateMessage( name, "Could not change greet message!" );
        }Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !addgreet " + msg );
    }
public void greet(String name, String msg){
if(oplist.isSmod(name))
try {
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/bdbot2/greet.txt"));
String line = "";
do {
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( name, "Current Greet Message: " + line );
} while ( line != null );
in.close();
 } catch( Exception e ){
m_botAction.sendPrivateMessage( name, "Uh Oh! greet.txt could not be found! Please report this to BDwinsAlt." );
log.add( "***Function Error***: greet.txt could not be found in the bot's root directory. Command given: !greet" );
Tools.printStackTrace( "Error reading greet.txt file. File may not exist.", e );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !greet " + msg );
}
public void givenews(String name, String msg){
if(oplist.isSmod(name))
try{
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/bdbot2/news.txt"));
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendArenaMessage( line );
} while ( line != null );
in.close();
 } catch( Exception e ){
m_botAction.sendPrivateMessage( name, "Uh Oh! news.txt could not be found in the twcore root directory!" );
log.add( "**Function Error**: News.txt could not be found in the bot's root directory. Command given !givenews." );
Tools.printStackTrace( "Error reading news.txt file. File may not exist.", e );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !givenews " + msg );
}
public void owner(String name, String msg){
String ownerz = m_botSettings.getString("BotOwner");
m_botAction.sendPrivateMessage( name, "Bot Owner: " + ownerz );
}
public void setnews(String name, String msg){
if(oplist.isSmod(name))
try{
            PrintWriter out = new PrintWriter( new FileWriter( "twcore/bots/bdbot2/news.txt" ));
            out.println( msg );
            out.close();
m_botAction.sendPrivateMessage( name, "Set News To: " + msg );
        }catch(Exception e){
            Tools.printStackTrace( e );
m_botAction.sendPrivateMessage( name, "Could not change news message!" );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !setnews " + msg );
}
public void kill(String name, String msg){
if(oplist.isER(name))
try{
Player p = m_botAction.getPlayer( msg );
           if(p != null)
m_botAction.sendUnfilteredPrivateMessage( p.getPlayerID(), "*kill" );
m_botAction.sendPrivateMessage( name, "Player Kicked." );
}catch(Exception e){
Tools.printStackTrace( e );
m_botAction.sendPrivateMessage( name, "Could not find player named: " + msg );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !kill " + msg );
}
public void spec(String name, String msg){
if(oplist.isER(name))
try {
Player p = m_botAction.getPlayer( msg );
if(p != null)
m_botAction.sendUnfilteredPrivateMessage( p.getPlayerID(), "*spec" );
m_botAction.sendPrivateMessage( name, "Player Spec'd." );
}catch(Exception e){
m_botAction.sendPrivateMessage( name, "Could not find player named " + msg );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !spec " + msg );
}
public void stfu(String name, String msg){
if(oplist.isER(name))
try{
Player p = m_botAction.getPlayer( msg );
if(p != null)
m_botAction.sendUnfilteredPrivateMessage( p.getPlayerID(), "*shutup" );
m_botAction.sendPrivateMessage( name, "Player Silenced." );
}catch(Exception e){
m_botAction.sendPrivateMessage( name, "Player not found." );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !stfu " + msg );
}
public void changelog(String name, String msg){
if(oplist.isSysop(name))
try {
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/bdbot2/changelog.txt"));
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( name, line );
} while ( line != null );
in.close();
 } catch(Exception e){
String ownerz = m_botSettings.getString("BotOwner");
m_botAction.sendPrivateMessage( name, "Oh No! Could not find changelog.txt. Please report this to " + ownerz + "!" );
try{
Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
            PrintWriter out = new PrintWriter( new FileWriter( "errors.txt" ));
            log.add( timestamp + "***Function Error***: Could not find changelog.txt." );
            log.add( "+Solution+: Making sure changelog.txt is in the root directory." );
            for( Iterator i = log.iterator(); i.hasNext(); ){
                out.println( (String)i.next() );
            }
            out.close();
}catch(Exception IO){
m_botAction.sendPrivateMessage( name, "Aslo failed to send an internal error message to errors.txt! I can't take life anymore!" );
}
}
}
public void buy(String name, String msg){
m_botAction.sendPrivateMessage( name, "You horny bastard! I like it ruff!" );
m_botAction.sendUnfilteredPrivateMessage( name, "*warn Don't be such a filthy animal." );
m_botAction.sendPrivateMessage( "BDwinsAlt", name + " has just bought you." );
}
public void info(String name, String msg){
String botname = m_botSettings.getString("Name1");
String botpass = m_botSettings.getString("Password1");
String ownerz = m_botSettings.getString("BotOwner");
String chat = m_botSettings.getString("Chat");
String bandays = m_botSettings.getString("BanDays");
String Iarena = m_botSettings.getString("InitialArena");
if(oplist.isSysop(name)){
m_botAction.sendPrivateMessage( name, "Bot Name:      " + botname );
m_botAction.sendPrivateMessage( name, "Bot Pass:      " + botpass );
m_botAction.sendPrivateMessage( name, "Bot Owner:     " + ownerz );
m_botAction.sendPrivateMessage( name, "Bot Chats:     " + chat );
m_botAction.sendPrivateMessage( name, "Bot BanDays:   " + bandays + " day(s)." );
m_botAction.sendPrivateMessage( name, "Intital Arena: " + Iarena );
} else {
m_botAction.sendPrivateMessage( name, "You are not authorized to view bot information." );
}
}
public void chat(String name, String msg){
if(oplist.isSysop(name)){
m_botAction.sendUnfilteredPublicMessage( "?chat=" + msg );
m_botAction.sendPrivateMessage( name, "Chat(s) set to: " + msg );
 } else {
m_botAction.sendPrivateMessage( name, "You must be a SysOp to set bot chats." );
 }
}
public void zone(String name, String msg){
if(oplist.isSmod(name)){
m_botAction.sendZoneMessage( msg + " -" + name );
 }Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !zone " + msg );
}
public void arena(String name, String msg){
if(oplist.isER(name)){
m_botAction.sendArenaMessage( msg + " -" + name );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !arena " + msg );
}
public void links(String name, String msg){
try{
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/bdbot2/links.txt"));
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( name, line );
} while ( line != null );
in.close();
 } catch( Exception e ){
m_botAction.sendPrivateMessage( name, "Uh Oh! links.txt could not be found in the twcore root directory!" );
log.add( "**Function Error**: links.txt could not be found in the twcore root directory. Command given !links." );
Tools.printStackTrace( "Error reading bdbot2links.txt file", e );
}
}
public void apply(String name, String msg){
            logg.add( name + " : " + msg );
m_botAction.sendPrivateMessage( name, "Application sent. Thank you." );
}
public void applyhelp(String name, String msg){
m_botAction.sendPrivateMessage( name, "Application Format: <age>,<skills>,<requested position>,<experiance>" );
m_botAction.sendPrivateMessage( name, "Example: !apply 19,Mapping,Mod,South Tejas(mod 3yrs.)" );
}
public void applicants(String name, String msg){
if(oplist.isSysop(name)){
for (int b = 0; b < logg.size(); b++) {
   m_botAction.sendPrivateMessage( name, "Applicant " + (b + 1) + ": " + logg.get(b) );
  }
if( logg.size() == 0 ){
m_botAction.sendPrivateMessage( name, "No applications found." );
} else {
m_botAction.sendPrivateMessage( name, "Total Applicants: " + logg.size() );
 }
}
}
public void delapps(String name, String msg){
if(oplist.isSysop(name)){
logg.clear();
m_botAction.sendPrivateMessage( name, "Applications Cleared." );
}else{
 m_botAction.sendPrivateMessage( name, "You are not authorized to use this command." );
m_botAction.sendChatMessage( name + " has tried to delete your staff applicants with !delapps." );
 }Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !delapps " + msg );
}
public void happybirthday(String name, String msg){
try {
Player p = m_botAction.getPlayer( msg );
           if(p != null)
m_botAction.sendUnfilteredPrivateMessage( p.getPlayerName(), "Happy Birthday! Just wishing a great guy a great BirthDay! - " + name );
m_botAction.sendPrivateMessage( name, "Birthday Message sent." );
 } catch( Exception IO ){
m_botAction.sendPrivateMessage( name, "Unable to find that player. Try again later." );
log.add( "ERROR***:Player not found when !happybirthday was given." );
   }
 } 
public void Coin(String name, String msg){
    Random rn = new Random();
    for (int i = 1; i <= 1; i++)
    m_botAction.sendPrivateMessage( name, (rn.nextBoolean() ?
      "Heads!" : "Tails!") );
  }
public void viewnews(String name, String msg){
if(oplist.isSmod(name)){
try {
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/bdbot2/news.txt"));
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( name, line );
} while ( line != null );
in.close();
 } catch( Exception e ){
m_botAction.sendPrivateMessage( name, "Uh Oh! news.txt could not be found in the twcore root directory!" );
log.add( "**Function Error**: news.txt could not be found in the twcore root directory. Command given !viewnews." );
Tools.printStackTrace( "Error reading news.txt file", e );
}
} else {
m_botAction.sendPrivateMessage( name, "You are not authorized to use this command." );
}
Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !viewnews " + msg );
}
public void hooker(String name, String msg){
m_botAction.sendPrivateMessage( name, "You are a hooker. Good Bye." );
}
public void ezpz(String name, String msg){
if(oplist.isSysop(name)){
Player p = m_botAction.getPlayer( msg );
           if(p != null)
m_botAction.sendArenaMessage( name + " has ezpz'd " + p.getPlayerName() + ". Everyone point and laugh at him!" );
} else {
m_botAction.sendPrivateMessage( name, "That player either wasn't found or you're not authorized to use this command." );
}Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !ezpz " + msg );
}
public void log(String name, String msg){
if(oplist.isSysop(name)){
if( cmdlog.size() == 0 ){
m_botAction.sendPrivateMessage( name, "No Commands on Log." );
} else {
for(int y = 0; y < cmdlog.size(); y++){
m_botAction.sendPrivateMessage( name, (y+1) + ") " + cmdlog.get(y) );
}
m_botAction.sendPrivateMessage( name, "Total Commands: " + cmdlog.size() );
}
}
}
public void logdel(String name, String msg){
if(oplist.isOwner(name))
cmdlog.clear();
m_botAction.sendPrivateMessage( name, "Command log cleared." );
System.out.println( "BD Bot 2.1: " + name + " has deleted the log." );
}
public void rules(String name, String msg){
try {
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/bdbot2/rules.txt"));
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( name, line );
} while ( line != null );
in.close();
 } catch( Exception e ){
m_botAction.sendPrivateMessage( name, "Uh Oh! rules.txt could not be found in the twcore root directory!" );
log.add( "**Function Error**: rules.txt could not be found in the twcore root directory. Command given !rules." );
Tools.printStackTrace( "Error reading rules.txt file", e );
}
}
public void giverules(String name, String msg){
if(oplist.isER(name)){
Player p = m_botAction.getPlayer( msg );
           if(p != null)
try {
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/bdbot2/rules.txt"));
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( p.getPlayerName(), line );
} while ( line != null );
in.close();
m_botAction.sendPrivateMessage( name, "I have sent the rules to " + p.getPlayerName() );
 } catch( Exception e ){
m_botAction.sendPrivateMessage( name, "Uh Oh! rules.txt could not be found in the twcore root directory!" );
log.add( "**Function Error**: rules.txt could not be found in the twcore root directory. Command given !rules." );
Tools.printStackTrace( "Error reading rules.txt file", e );
}
}
Calendar c = Calendar.getInstance();
        String timestamp = c.get( c.MONTH ) + "/" + c.get( c.DAY_OF_MONTH )
        + "/" + c.get( c.YEAR ) + " - ";
cmdlog.add( timestamp + name + " : !giverules " + msg );
}
//8ball is cool! It displays Yes and No most offten.
public void rand(String name, String msg){
Random r = new Random();
  int randInt = Math.abs(r.nextInt()) % 14;
if( randInt == 1 ){
m_botAction.sendPrivateMessage( name, "Yes." );
} else if(randInt == 2){
m_botAction.sendPrivateMessage( name, "No." );
} else if(randInt == 3){
m_botAction.sendPrivateMessage( name, "Maybe." );
} else if(randInt == 4){
m_botAction.sendPrivateMessage( name, "It's possible." );
} else if(randInt == 5){
m_botAction.sendPrivateMessage( name, "Is that a trick question?" );
} else if(randInt == 6){
m_botAction.sendPrivateMessage( name, "Can you repeat that?" );
} else if(randInt == 7){
m_botAction.sendPrivateMessage( name, "I'm not even going to awnser that." );
} else if(randInt == 8){
m_botAction.sendPrivateMessage( name, "Yes." );
} else if(randInt == 9){
m_botAction.sendPrivateMessage( name, "No." );
} else if(randInt == 10){
m_botAction.sendPrivateMessage( name, "No." );
} else if(randInt == 11){
m_botAction.sendPrivateMessage( name, "Yes." );
} else if(randInt == 12){
m_botAction.sendPrivateMessage( name, "Yea." );
} else if(randInt == 13){
m_botAction.sendPrivateMessage( name, "Nah." );
} else {
m_botAction.sendPrivateMessage( name, "Maybe." );
}
}
//buptime will be perfected soon.
public void buptime(String name, String msg){
if(oplist.isSmod(name))
try {
BufferedReader in = new BufferedReader( new FileReader("twcore/bots/time.log"));
String line = "";
do{
line = in.readLine();
if( line == null ) break;
m_botAction.sendPrivateMessage( name, line );
} while ( line != null );
in.close();
 } catch( Exception e ){
 m_botAction.sendPrivateMessage( name, "Could not find time information." );
 }
}
//Stop all coding before this comment. You could accidentally erase the ending "}".
}